package guest;
 
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;
 
@Stateless
public class GuestDao {
    // Injected database connection:
    @PersistenceContext private EntityManager em;
 
    // Stores a new guest:
    public void persist(Guest guest) {
        em.persist(guest);
        
        em.flush();
        
        Long id=guest.id;
        
       
        
        
        //option 1// Doesn't Work // Caannot retrieve the abstract guest
        AbstractGuest last=em.find(AbstractGuest.class,id);
        
        
        
        //option 2//Works
        //Guest last=em.find(Guest.class,id);
        
        if(last==null)System.out.println("Last is NuLL!!!!!!!!!!!!!!!!");
        
        em.persist(new Guest("DummyA("+last+")"));
        
        
        
        
        
    }
 
    // Retrieves all the guests:
    public List<Guest> getAllGuests() {
        TypedQuery<Guest> query = em.createQuery(
            "SELECT g FROM Guest g ORDER BY g.id", Guest.class);
        return query.getResultList();
    }
    
    public Guest getFirst(){
    	
    	return em.find(Guest.class,1);
    }
}